// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { LogError } from "../../../../core/decorator/LogErrorDecorator";
import { ComplianceRequest, SetComplianceRequest } from "../../request";
import ValidatedRequest from "../../../../core/validation/ValidatedArgs";
import { SetComplianceCommand } from "../../../../app/usecase/command/security/compliance/setCompliance/SetComplianceCommand";
import { ComplianceQuery } from "../../../../app/usecase/query/security/compliance/compliance/ComplianceQuery";
import { BaseSecurityInPort } from "../BaseSecurityInPort";
export class SecurityInPortCompliance extends BaseSecurityInPort {
    async setCompliance(request) {
        const { securityId, compliance } = request;
        ValidatedRequest.handleValidation("SetComplianceRequest", request);
        return await this.commandBus.execute(new SetComplianceCommand(securityId, compliance));
    }
    async compliance(request) {
        const { securityId } = request;
        ValidatedRequest.handleValidation("ComplianceRequest", request);
        return (await this.queryBus.execute(new ComplianceQuery(securityId))).payload;
    }
}
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SetComplianceRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortCompliance.prototype, "setCompliance", null);
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ComplianceRequest]),
    __metadata("design:returntype", Promise)
], SecurityInPortCompliance.prototype, "compliance", null);
